diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 92e9a6ad9..d2da4d3e4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -171,6 +171,7 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGenericSlab<>(Blocks.SLAB_BRICK_SANDSTONE, loadDataModel("minecraft:block/slab/brick_sandstone/lower"), loadDataModel("minecraft:block/slab/brick_sandstone/upper"), loadDataModel("minecraft:block/slab/brick_sandstone/full")));
         addDispatch(new BlockModelGenericSlab<>(Blocks.SLAB_BRICK_PERMAFROST, loadDataModel("minecraft:block/slab/brick_permafrost/lower"), loadDataModel("minecraft:block/slab/brick_permafrost/upper"), loadDataModel("minecraft:block/slab/brick_permafrost/full")));
 
+        addDispatch(new BlockModelGenericSlab<>(Blocks.SLAB_BRICK_RUBYGLASS, loadDataModel("minecraft:block/rubyglass/slab/brick/lower"), loadDataModel("minecraft:block/rubyglass/slab/brick/upper"), loadDataModel("minecraft:block/rubyglass/slab/brick/full")));
         addDispatch(new BlockModelGenericSlab<>(Blocks.SLAB_BRICK_DIAMOND, loadDataModel("minecraft:block/slab/brick_diamond/lower"), loadDataModel("minecraft:block/slab/brick_diamond/upper"), loadDataModel("minecraft:block/slab/brick_diamond/full")));
         addDispatch(new BlockModelGenericSlab<>(Blocks.SLAB_BRICK_IRON, loadDataModel("minecraft:block/slab/brick_iron/lower"), loadDataModel("minecraft:block/slab/brick_iron/upper"), loadDataModel("minecraft:block/slab/brick_iron/full")));
         addDispatch(new BlockModelGenericSlab<>(Blocks.SLAB_BRICK_GOLD, loadDataModel("minecraft:block/slab/brick_gold/lower"), loadDataModel("minecraft:block/slab/brick_gold/upper"), loadDataModel("minecraft:block/slab/brick_gold/full")));
@@ -198,6 +199,7 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGenericStairs<>(Blocks.STAIRS_BRICK_SANDSTONE, loadDataModel("minecraft:block/stairs/brick_sandstone")));
         addDispatch(new BlockModelGenericStairs<>(Blocks.STAIRS_BRICK_PERMAFROST, loadDataModel("minecraft:block/stairs/brick_permafrost")));
 
+        addDispatch(new BlockModelGenericStairs<>(Blocks.STAIRS_BRICK_RUBYGLASS, loadDataModel("minecraft:block/rubyglass/stairs/brick")));
         addDispatch(new BlockModelGenericStairs<>(Blocks.STAIRS_BRICK_DIAMOND, loadDataModel("minecraft:block/stairs/brick_diamond")));
         addDispatch(new BlockModelGenericStairs<>(Blocks.STAIRS_BRICK_IRON, loadDataModel("minecraft:block/stairs/brick_iron")));
         addDispatch(new BlockModelGenericStairs<>(Blocks.STAIRS_BRICK_GOLD, loadDataModel("minecraft:block/stairs/brick_gold")));
@@ -242,12 +244,12 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGenericFullyRotatable<>(Blocks.BONESHALE,
                 loadDataModel("minecraft:block/bone_shale")));
 
-        addDispatch(new BlockModelFluid<>(Blocks.FLUID_WATER_FLOWING, "minecraft:block/water_still", "minecraft:block/water_flowing")
+        addDispatch(new BlockModelFluid<>(Blocks.FLUID_WATER_FLOWING, "minecraft:block/fluid/water/still", "minecraft:block/fluid/water/flowing")
             .onRenderLayer(1));
-        addDispatch(new BlockModelFluid<>(Blocks.FLUID_WATER_STILL, "minecraft:block/water_still", "minecraft:block/water_flowing")
+        addDispatch(new BlockModelFluid<>(Blocks.FLUID_WATER_STILL, "minecraft:block/fluid/water/still", "minecraft:block/fluid/water/flowing")
             .onRenderLayer(1));
-        addDispatch(new BlockModelFluid<>(Blocks.FLUID_LAVA_FLOWING, "minecraft:block/lava_still", "minecraft:block/lava_flowing"));
-        addDispatch(new BlockModelFluid<>(Blocks.FLUID_LAVA_STILL, "minecraft:block/lava_still", "minecraft:block/lava_flowing"));
+        addDispatch(new BlockModelFluid<>(Blocks.FLUID_LAVA_FLOWING, "minecraft:block/fluid/lava/still", "minecraft:block/fluid/lava/flowing"));
+        addDispatch(new BlockModelFluid<>(Blocks.FLUID_LAVA_STILL, "minecraft:block/fluid/lava/still", "minecraft:block/fluid/lava/flowing"));
 
         addDispatch(new BlockModelGenericAxis<>(Blocks.LOG_OAK, loadDataModel("minecraft:block/log/oak")));
         addDispatch(new BlockModelGenericAxis<>(Blocks.LOG_PINE, loadDataModel("minecraft:block/log/pine")));
@@ -289,7 +291,7 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGeneric<>(Blocks.ALGAE, loadDataModel("minecraft:block/algae")).render3D(false));
 
         addDispatch(new BlockModelGeneric<>(Blocks.BONE_PILE, loadDataModel("minecraft:block/bone_pile")).render3D(false));
-        addDispatch(new BlockModelGeneric<>(Blocks.SOULCATCHER, loadDataModel("minecraft:block/soul_catcher")).render3D(false));
+        addDispatch(new BlockModelGeneric<>(Blocks.SOUL_CATCHER, loadDataModel("minecraft:block/soul_catcher")).render3D(false));
 
         addDispatch(new BlockModelGenericFlowerStackable<>(Blocks.FLOWER_YELLOW, "minecraft:block/flower_yellow/").render3D(false));
         addDispatch(new BlockModelGenericFlowerStackable<>(Blocks.FLOWER_RED, "minecraft:block/flower_red/").render3D(false));
@@ -344,10 +346,12 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGeneric<>(Blocks.ORE_DIAMOND_PERMAFROST, loadDataModel("minecraft:block/ore/diamond/permafrost")));
 
         addDispatch(new BlockModelGeneric<>(Blocks.RUBYGLASS_COLUMN, loadDataModel("minecraft:block/rubyglass/column")));
-        addDispatch(new BlockModelGeneric<>(Blocks.RUBYGLASS_NODE, loadDataModel("minecraft:block/rubyglass/node")));
+        addDispatch(new BlockModelGeneric<>(Blocks.RUBYGLASS_NODE, loadDataModel("minecraft:block/rubyglass/node")).forceCullSelf(true));
+        addDispatch(new BlockModelGeneric<>(Blocks.BRICK_RUBYGLASS, loadDataModel("minecraft:block/rubyglass/brick")));
         addDispatch(new BlockModelGeneric<>(Blocks.BLOCK_RUBYGLASS, loadDataModel("minecraft:block/rubyglass/block")).forceCullSelf(true));
-        addDispatch(new BlockModelCrystalBud<>(Blocks.RUBYGLASS_SPROUT, loadDataModel("minecraft:block/rubyglass/sprout")).render3D(false));
-        addDispatch(new BlockModelConduit<>(Blocks.CONDUIT));
+        addDispatch(new BlockModelConduit<>(Blocks.CONDUIT).forceCullSelf(true));
+        addDispatch(new BlockModelGenericRubyglassCrystal<>(Blocks.RUBYGLASS_CRYSTAL, loadDataModel("minecraft:block/rubyglass/crystal/0")).forceCullSelf(true));
+        addDispatch(new BlockModelGenericRubyglassGrowth<>(Blocks.RUBYGLASS_GROWTH));
 
         addDispatch(new BlockModelGeneric<>(Blocks.ORE_NETHERCOAL_NETHERRACK, loadDataModel("minecraft:block/ore/nethercoal/netherrack")));
         addDispatch(new BlockModelGeneric<>(Blocks.ORE_NETHERCOAL_BASALT, loadDataModel("minecraft:block/ore/nethercoal/basalt")));
@@ -425,7 +429,7 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGenericSpikes<>(Blocks.SPIKES).render3D(false));
 
         addDispatch(new BlockModelGenericVeryRotatable<>(Blocks.DISPENSER_COBBLE_STONE, loadDataModel("minecraft:block/dispenser")));
-        addDispatch(new BlockModelGenericActivator<>(Blocks.ACTIVATOR_COBBLE_NETHERRACK));
+        addDispatch(new BlockModelGenericActivator<>(Blocks.ACTIVATOR));
 
         addDispatch(new BlockModelGenericTrapdoor<>(Blocks.TRAPDOOR_PLANKS_OAK, "minecraft:block/trapdoor/planks/oak"));
         addDispatch(new BlockModelGenericTrapdoor<>(Blocks.TRAPDOOR_IRON, "minecraft:block/trapdoor/iron"));
@@ -457,6 +461,7 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGeneric<>(Blocks.BRAZIER_INACTIVE, loadDataModel("minecraft:block/brazier")));
         addDispatch(new BlockModelGenericBrazier<>(Blocks.BRAZIER_ACTIVE, loadDataModel("minecraft:block/brazier")));
         addDispatch(new BlockModelFire<>(Blocks.FIRE_COLD).setAllTextures("minecraft:block/fire_cold"));
+        addDispatch(new BlockModelFire<>(Blocks.FIRE_SULFURIC).setAllTextures("minecraft:block/fire_sulfuric"));
 
         addDispatch(new BlockModelGeneric<>(Blocks.MOBSPAWNER, loadDataModel("minecraft:block/mobspawner")));
         addDispatch(new BlockModelGeneric<>(Blocks.MOBSPAWNER_DEACTIVATED, loadDataModel("minecraft:block/mobspawner_deactivated")));
@@ -490,7 +495,7 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGenericLayer<>(Blocks.LAYER_SNOW, "minecraft:block/layer/snow"));
         addDispatch(new BlockModelGenericLayer<>(Blocks.LAYER_LEAVES_OAK, "minecraft:block/layer/leaves_oak"));
         addDispatch(new BlockModelGenericLayer<>(Blocks.LAYER_SLATE, "minecraft:block/layer/slate"));
-        addDispatch(new BlockModelGenericLayer<>(Blocks.LAYER_ASH, "minecraft:block/layer/ash"));
+        addDispatch(new BlockModelGenericLayerAsh<>(Blocks.LAYER_ASH));
 
         addDispatch(new BlockModelGeneric<>(Blocks.ICE, loadDataModel("minecraft:block/ice")).forceCullSelf(true));
         addDispatch(new BlockModelGeneric<>(Blocks.PERMAICE, loadDataModel("minecraft:block/permaice")));
@@ -588,7 +593,39 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGenericStairs<>(Blocks.STAIRS_COBBLE_GLOOMSTONE, loadDataModel("minecraft:block/stairs/cobbled_gloomstone")));
         addDispatch(new BlockModelGenericStairs<>(Blocks.STAIRS_BRICK_GLOOMSTONE, loadDataModel("minecraft:block/stairs/brick_gloomstone")));
 
-        addDispatch(new BlockModelGenericFlowstone<>(Blocks.FLOWSTONE, "minecraft:block/flowstone"));
+        addDispatch(new BlockModelGeneric<>(Blocks.BOULDER_MAGMATIC, loadDataModel("minecraft:block/boulder_magmatic")).render3D(false));
+        addDispatch(new BlockModelGeneric<>(Blocks.BOULDER_SULFURIC, loadDataModel("minecraft:block/boulder_sulfuric")).render3D(false));
+        addDispatch(new BlockModelGeneric<>(Blocks.SULFUR, loadDataModel("minecraft:block/sulfur")));
+        addDispatch(new BlockModelGeneric<>(Blocks.SULFUR_HARDENED, loadDataModel("minecraft:block/sulfur_hardened")));
+        addDispatch(new BlockModelGeneric<>(Blocks.EMBER, loadDataModel("minecraft:block/ember")));
+        addDispatch(new BlockModelGeneric<>(Blocks.SLATE_CARVED, loadDataModel("minecraft:block/carved_slate")));
+        addDispatch(new BlockModelGeneric<>(Blocks.BRIMSTONE, loadDataModel("minecraft:block/brimstone")));
+        addDispatch(new BlockModelGeneric<>(Blocks.BRIMTHAW, loadDataModel("minecraft:block/brimthaw")));
+        addDispatch(new BlockModelGeneric<>(Blocks.BRICK_BRIMSTONE, loadDataModel("minecraft:block/brick_brimstone")));
+
+        addDispatch(new BlockModelGenericAxis<>(Blocks.LOG_SCORCHED, loadDataModel("minecraft:block/log/scorched")));
+
+        addDispatch(new BlockModelGenericSlab<>(Blocks.SLAB_BRIMSTONE, loadDataModel("minecraft:block/slab/brimstone/lower"), loadDataModel("minecraft:block/slab/brimstone/upper"), loadDataModel("minecraft:block/slab/brimstone/full")));
+        addDispatch(new BlockModelGenericStairs<>(Blocks.STAIRS_BRIMSTONE, loadDataModel("minecraft:block/stairs/brimstone")));
+
+        addDispatch(new BlockModelGenericSlab<>(Blocks.SLAB_BRICK_BRIMSTONE, loadDataModel("minecraft:block/slab/brick_brimstone/lower"), loadDataModel("minecraft:block/slab/brick_brimstone/upper"), loadDataModel("minecraft:block/slab/brick_brimstone/full")));
+        addDispatch(new BlockModelGenericStairs<>(Blocks.STAIRS_BRICK_BRIMSTONE, loadDataModel("minecraft:block/stairs/brick_brimstone")));
+
+        addDispatch(new BlockModelGenericSlab<>(Blocks.SLAB_SLATE_POLISHED, loadDataModel("minecraft:block/slab/polished_slate/lower"), loadDataModel("minecraft:block/slab/polished_slate/upper"), loadDataModel("minecraft:block/slab/polished_slate/full")));
+
+        addDispatch(new BlockModelFluid<>(Blocks.FLUID_ACID_FLOWING, "minecraft:block/fluid/acid/still", "minecraft:block/fluid/acid/flowing").onRenderLayer(1));
+        addDispatch(new BlockModelFluid<>(Blocks.FLUID_ACID_STILL, "minecraft:block/fluid/acid/still", "minecraft:block/fluid/acid/flowing").onRenderLayer(1));
+
+        addDispatch(new BlockModelEmpty<>(Blocks.STATUE_SLATE_LOWER).setAllTextures("minecraft:block/slate_side"));
+        addDispatch(new BlockModelEmpty<>(Blocks.STATUE_SLATE_UPPER).setAllTextures("minecraft:block/slate_side"));
+        addDispatch(new BlockModelEmpty<>(Blocks.STATUE_PERMAFROST_LOWER).setAllTextures("minecraft:block/permafrost"));
+        addDispatch(new BlockModelEmpty<>(Blocks.STATUE_PERMAFROST_UPPER).setAllTextures("minecraft:block/permafrost"));
+        addDispatch(new BlockModelEmpty<>(Blocks.STATUE_NETHERRACK_LOWER).setAllTextures("minecraft:block/netherrack"));
+        addDispatch(new BlockModelEmpty<>(Blocks.STATUE_NETHERRACK_UPPER).setAllTextures("minecraft:block/netherrack"));
+        addDispatch(new BlockModelEmpty<>(Blocks.STATUE_GLOOMSTONE_LOWER).setAllTextures("minecraft:block/gloomstone"));
+        addDispatch(new BlockModelEmpty<>(Blocks.STATUE_GLOOMSTONE_UPPER).setAllTextures("minecraft:block/gloomstone"));
+
+
     }
 }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
index 5e9a2d954..1dba8e7f7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
@@ -36,7 +36,7 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
         super(block);
         this.still = TextureRegistry.getTexture(still);
         this.flowing = TextureRegistry.getTexture(flowing);
-        this.bubbles = TextureRegistry.getTexture("minecraft:block/water_overlay_boiling");
+        this.bubbles = TextureRegistry.getTexture("minecraft:block/fluid/water/overlay_boiling");
 
         if (block.getLogic() instanceof BlockLogicFluidFlowing) {
             setAllTextures(this.flowing);
@@ -94,10 +94,12 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
             } else {
                 rotation = 0.0F;
             }
-            byte light = this.block.getLightIndex(worldSource, tilePos);
-            byte lightUp = this.block.getLightIndex(worldSource, tilePos.up(queryPos));
 
-            tessellator.setLightmapCoord1i(LightIndexHelper.max(light, lightUp));
+            byte lightNW = getFluidVertexLight(worldSource, (TilePos) tilePos, -1, -1, queryPos);
+            byte lightSW = getFluidVertexLight(worldSource, (TilePos) tilePos, -1, 1, queryPos);
+            byte lightSE = getFluidVertexLight(worldSource, (TilePos) tilePos, 1, 1, queryPos);
+            byte lightNE = getFluidVertexLight(worldSource, (TilePos) tilePos, 1, -1, queryPos);
+
             if (tex == this.flowing) {
                 float cos = Math.cos(-rotation + Math.PI_OVER_2_f);
                 float sin = Math.sin(-rotation + Math.PI_OVER_2_f);
@@ -112,27 +114,43 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
                 this.b.cross(this.a, this.norm).normalize();
 
                 tessellator.setNormal(this.norm);
+
+                tessellator.setLightmapCoord1i(lightNW);
                 tessellator.addVertexWithUV(x, (float) y + h, z,
                     tex.getSubIconU(((-0.25) * cos - (-0.25) * sin) + 0.5),
                     tex.getSubIconV(((-0.25) * sin + (-0.25) * cos) + 0.5)
                 );
+
+                tessellator.setLightmapCoord1i(lightSW);
                 tessellator.addVertexWithUV(x, (float) y + hs, z + 1,
                     tex.getSubIconU(((-0.25) * cos - (0.25) * sin) + 0.5),
                     tex.getSubIconV(((-0.25) * sin + (0.25) * cos) + 0.5)
                 );
+
+                tessellator.setLightmapCoord1i(lightSE);
                 tessellator.addVertexWithUV(x + 1, (float) y + hes, z + 1,
                     tex.getSubIconU(((0.25) * cos - (0.25) * sin) + 0.5),
                     tex.getSubIconV(((0.25) * sin + (0.25) * cos) + 0.5)
                 );
+
+                tessellator.setLightmapCoord1i(lightNE);
                 tessellator.addVertexWithUV(x + 1, (float) y + he, z,
                     tex.getSubIconU(((0.25) * cos - (-0.25) * sin) + 0.5),
                     tex.getSubIconV(((0.25) * sin + (-0.25) * cos) + 0.5)
                 );
             } else {
                 tessellator.setNormal(0, 1, 0);
+
+                tessellator.setLightmapCoord1i(lightNW);
                 tessellator.addVertexWithUV(x, (float) y + h, z, tex.getIconUMin(), tex.getIconVMax());
+
+                tessellator.setLightmapCoord1i(lightSW);
                 tessellator.addVertexWithUV(x, (float) y + hs, z + 1, tex.getIconUMax(), tex.getIconVMax());
+
+                tessellator.setLightmapCoord1i(lightSE);
                 tessellator.addVertexWithUV(x + 1, (float) y + hes, z + 1, tex.getIconUMax(), tex.getIconVMin());
+
+                tessellator.setLightmapCoord1i(lightNE);
                 tessellator.addVertexWithUV(x + 1, (float) y + he, z, tex.getIconUMin(), tex.getIconVMin());
 
                 if (worldSource.getWorldType().hasTag(WorldTypeTags.NETHER) && this.block.getLogic().fluid instanceof FluidWater) {
@@ -288,4 +306,15 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
             return super.shouldSideBeRendered(source, bounds, tilePos, side);
         }
     }
+
+    private byte getFluidVertexLight(WorldSource world, TilePos center, int dx, int dz, TilePos queryPos) {
+        byte l1 = this.block.getLightIndex(world, center.up(queryPos));
+        byte l2 = this.block.getLightIndex(world, center.add(dx, 1, 0, queryPos));
+        byte l3 = this.block.getLightIndex(world, center.add(0, 1, dz, queryPos));
+        byte l4 = this.block.getLightIndex(world, center.add(dx, 1, dz, queryPos));
+
+        byte max1 = LightIndexHelper.max(l1, l2);
+        byte max2 = LightIndexHelper.max(l3, l4);
+        return LightIndexHelper.max(max1, max2);
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java
index 16fac720f..a5be6ed64 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicPumpkin;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
@@ -48,7 +49,7 @@ public class BlockModelGeneric<T extends BlockLogic> extends BlockModel<T> {
     }
 
     @Override
-    public final boolean render(final @NotNull TessellatorGeneral tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(final @NotNull TessellatorGeneral tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos) {
         return renderAttached(tessellator, worldSource, tilePos, true, null);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLayerAsh.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLayerAsh.java
new file mode 100644
index 000000000..11258d9a0
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLayerAsh.java
@@ -0,0 +1,28 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+
+public class BlockModelGenericLayerAsh<T extends BlockLogic> extends BlockModelGenericLayer<T> {
+
+    public final BlockModelGenericLayer<T> emberModel;
+
+    public BlockModelGenericLayerAsh(@NotNull Block<T> block) {
+        super(block, "minecraft:block/ash");
+        this.emberModel = new BlockModelGenericLayer<>(block, "minecraft:block/ash_ember");
+    }
+
+    @Override
+    public boolean render(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        if (worldSource.getBlockId(tilePos.x(), tilePos.y() - 1, tilePos.z()) == Blocks.EMBER.id()) {
+            return this.emberModel.render(tessellator, worldSource, tilePos);
+        }
+
+        return super.render(tessellator, worldSource, tilePos);
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRocks.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRocks.java
new file mode 100644
index 000000000..832e3b8f5
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRocks.java
@@ -0,0 +1,25 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericRocks<T extends BlockLogic> extends BlockModelGeneric<T> {
+	public final @NotNull StaticBlockModel[] models = new StaticBlockModel[3];
+
+	public BlockModelGenericRocks(@NotNull Block<T> block) {
+		super(block, BlockModelDispatcher.loadDataModel("minecraft:block/rocks/0"));
+
+		for(int i = 0; i < 3; ++i) {
+			this.models[i] = BlockModelDispatcher.loadDataModel("minecraft:block/rocks/" + i).asModel();
+		}
+
+	}
+
+	@Override
+	public @NotNull StaticBlockModel getModelFromData(int data) {
+		return this.models[data % 3];
+	}
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRubyglassCrystal.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRubyglassCrystal.java
new file mode 100644
index 000000000..0a5e7a394
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRubyglassCrystal.java
@@ -0,0 +1,33 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericRubyglassCrystal<T extends BlockLogic> extends BlockModelGeneric<T> {
+	public final StaticBlockModel[] models = new StaticBlockModel[4];
+
+	public BlockModelGenericRubyglassCrystal(@NotNull Block<T> block, @NotNull StaticBlockModel staticModel) {
+		super(block, staticModel);
+		loadModels();
+	}
+
+	public BlockModelGenericRubyglassCrystal(@NotNull Block<T> block, @NotNull BlockModelData staticModel) {
+		super(block, staticModel);
+		loadModels();
+	}
+
+	private void loadModels() {
+		for (int i = 0; i < 4; i++) {
+			this.models[i] = BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass/crystal/" + i).asModel();
+		}
+	}
+
+	@Override
+	public @NotNull StaticBlockModel getModelFromData(int data) {
+		return this.models[data & 3];
+	}
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRubyglassGrowth.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRubyglassGrowth.java
new file mode 100644
index 000000000..f0488a930
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRubyglassGrowth.java
@@ -0,0 +1,85 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModel;
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.DisplayPos;
+
+import static net.minecraft.core.block.BlockLogicGrowthRubyglass.*;
+
+public class BlockModelGenericRubyglassGrowth<T extends BlockLogic> extends BlockModel<T> {
+
+    public final BlockModelGenericFullyRotatable<T> budModel;
+    public final BlockModelGenericFullyRotatable<T> bottomModel;
+    public final BlockModelGenericFullyRotatable<T> topModel;
+
+    public BlockModelGenericRubyglassGrowth(@NotNull Block<T> block) {
+        super(block);
+        this.budModel = new BlockModelGenericFullyRotatable<>(block, BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass/growth/bud"));
+        this.bottomModel = new BlockModelGenericFullyRotatable<>(block, BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass/growth/bottom"));
+        this.topModel = new BlockModelGenericFullyRotatable<>(block, BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass/growth/top"));
+    }
+
+    @Override
+    public boolean render(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        int data = worldSource.getBlockData(tilePos);
+
+        int shape = data & SHAPE_MASK;
+
+        if (shape == STATE_TOP) {
+            return this.topModel.render(tessellator, worldSource, tilePos);
+        } else if (shape == STATE_BOTTOM) {
+            return this.bottomModel.render(tessellator, worldSource, tilePos);
+        } else {
+            return this.budModel.render(tessellator, worldSource, tilePos);
+        }
+    }
+
+    @Override
+    public boolean renderNoCulling(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        return false;
+    }
+
+    @Override
+    public boolean renderWithOverrideTexture(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, IconCoordinate overrideTexture) {
+        return false;
+    }
+
+    @Override
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, byte lightIndex) {
+        this.budModel.renderStandalone(tessellator, metadata, lightIndex);
+    }
+
+    @Override
+    public boolean shouldItemRender3d() {
+        return false;
+    }
+
+    @Override
+    public @NotNull DisplayPos getItemDisplayPos(@NotNull String id) {
+        return this.budModel.getItemDisplayPos(id);
+    }
+
+    @Override
+    public @Nullable IconCoordinate getParticleTexture(@NotNull Side side, int meta) {
+        return this.budModel.getParticleTexture(side, meta);
+    }
+
+    @Override
+    public @Nullable IconCoordinate getOverlayTexture(int meta) {
+        return this.budModel.getOverlayTexture(meta);
+    }
+
+    @Override
+    public int particleColorIndex(@NotNull WorldSource worldSource, @NotNull TilePosc tilePos, @NotNull Side side, int meta) {
+        return this.budModel.particleColorIndex(worldSource, tilePos, side, meta);
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFire.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFire.java
index 034c2746f..92bd27c87 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFire.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFire.java
@@ -10,11 +10,13 @@ public class DynamicTextureFire extends DynamicTexture{
 	private int height;
 	private float scaleFactor;
 
+	private final boolean sulfuric;
 	private final boolean cold;
 
-	public DynamicTextureFire(@NotNull IconCoordinate targetTexture, boolean cold) {
+	public DynamicTextureFire(@NotNull IconCoordinate targetTexture, boolean cold, boolean sulfuric) {
 		super(targetTexture);
 
+		this.sulfuric = sulfuric;
 		this.cold = cold;
 	}
 
@@ -73,6 +75,10 @@ public class DynamicTextureFire extends DynamicTexture{
 				r = (int)(l * 155.0F + 100.0F);
 				g = (int)(l * 155.0F + 100.0F);
 				b = (int)(l * 155.0F + 100.0F);
+			} else if (this.sulfuric) {
+				r = (int)(l * 200.0F + 55.0F);
+				g = (int)(l * 155.0F + 100.0F);
+				b = (int)(l * l * l * l * l * l * l * l * l * l * 255.0F);
 			} else {
 				r = (int)(l * 155.0F + 100.0F);
 				g = (int)(l * l * 255.0F);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
index 865195a21..28ea1fa62 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
@@ -15,6 +15,7 @@ import org.jetbrains.annotations.NotNull;
 import org.joml.Math;
 import org.joml.primitives.AABBdc;
 
+import net.minecraft.client.render.ClientFireOverlayHelper;
 import net.minecraft.client.render.EntityRendererDispatcher;
 import net.minecraft.client.render.ImageParser;
 import net.minecraft.client.render.TextureManager;
@@ -103,7 +104,8 @@ public abstract class EntityRenderer<T extends Entity> {
 
     private void renderFire(final @NotNull TessellatorGeneral tessellator, final @NotNull T entity, final double x, final double y, final double z, final float partialTick) {
         GLRenderer.globalSetLightEnabled(false);
-        final IconCoordinate texture = TextureRegistry.getTexture("minecraft:block/fire");
+        final String texturePath = ClientFireOverlayHelper.getFireOverlayTexture(entity);
+        final IconCoordinate texture = TextureRegistry.getTexture(texturePath);
         texture.parentAtlas.bind();
         GLRenderer.pushFrame();
         GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
@@ -118,6 +120,7 @@ public abstract class EntityRenderer<T extends Entity> {
         GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         byte lightIndex = entity.getLightIndex(partialTick);
         lightIndex = LightIndexHelper.setBlockLight(lightIndex, 15);
+        lightIndex = LightIndexHelper.setSkyLight(lightIndex, 15);
         GLRenderer.setLightmapCoord1i(lightIndex);
         float f14 = 0.0F;
         int l = 0;
